//http://seta43.hol.es/electro.html
//xsetaseta@gmail.com 
//08/03/2018
//OLED

#include "olex.h"
#include <Wire.h>

#include <OneWire.h>
OneWire ds(2); // pin utilizado para el bus Onewire
int Otemperatura;
char bufferTemp[10];


int time1;


void setup() 
{
  Wire.begin();
  OleInit();
  clearDisplay();
  display();
  ModeFont=0;  ModeDisplay=1;   StringAT(0,3,"Temperatura");
  time1=4000;
}

void loop() 
{
  delay(1);
  time1++;
  if(time1>4000)
  {
     time1=0;
     if(0==getTemp()) getTemp();
     sprintf(bufferTemp,"%d,%d%cC",Otemperatura/10,Otemperatura%10,127); 
     ModeFont=2; StringAT(0,5,bufferTemp);
  }
 
}


//______________________________________________________
//ds18B20

int getTemp()
{
  byte data[12];
  byte addr[8];
  int z;
  long  temp;
 
  if ( !ds.search(addr))   { ds.reset_search(); return 0; }
  if ( OneWire::crc8( addr, 7) != addr[7]) ;// { SERIECONSOLA.println(F("CRC is not valid!")); return -1; }
  if ( addr[0] != 0x10 && addr[0] != 0x28) ;// { SERIECONSOLA.print(F("Device is not recognized")); return -1; }

  ds.reset();  ds.select(addr);  ds.write(0x4E);         
  ds.write(0x4B);    
  ds.write(0x46);    
  ds.write(0x7F);    // 12-bit sampling resolution (default)
  //ds.write(0x5F);    // 11-bit
  //ds.write(0x3F);    // 10-bit
  //ds.write(0x1F);    // 9-bit
  // delay(500); 

  ds.reset();  ds.select(addr);  ds.write(0x44,1); // start conversion, with parasite power on at the end
  delay(750);  

  ds.reset();  ds.select(addr);  ds.write(0xBE); // Read Scratchpad
  for ( z = 0; z < 9; z++) data[z] = ds.read();
    
  z = (data[1] << 8) | data[0];
  temp=z;
  temp=(temp*625)/1000;  
  Otemperatura=temp;
  return 1;  
}

